PROGRAM MATRIX_SUBTRACTION

!  Purpose:
!    To read in two matrices from a disk file and subtract them.  (This quick-
!    and-dirty program lacks some of the error checking that a production 
!    program should include.)

!  Record of revisions:
!      Date       Programmer          Description of change
!      ====       ==========          =====================
!    10/15/93    S. J. Chapman        Original code

IMPLICIT NONE

!  Declare parameters.

INTEGER, PARAMETER :: SHORT  = 1    ! Single precision is KIND=1 on this machine
INTEGER, PARAMETER :: INT32  = 3    ! 32-bit integers are KIND=3 on this machine
INTEGER, PARAMETER :: MAXROW = 4    ! Maximum number of rows
INTEGER, PARAMETER :: MAXCOL = 4    ! Maximum number of columns


!  Declare the variables used in this program.

REAL (KIND=SHORT) A(MAXROW,MAXCOL) ! Matrix A
REAL (KIND=SHORT) B(MAXROW,MAXCOL) ! Matrix B
REAL (KIND=SHORT) C(MAXROW,MAXCOL) ! Matrix C
INTEGER (KIND=INT32) I             ! Index variable
INTEGER (KIND=INT32) J             ! Index variable
INTEGER (KIND=INT32) M             ! Number of rows in matrices
INTEGER (KIND=INT32) N             ! Number of columns in matrices

! Get matrix size.

WRITE (*,*) 'Enter matrix size (N x M):'
READ (*,*) N, M

! Get matrix A.

DO I = 1, N
   DO J = 1, M
      WRITE (*,'(1X,A,I2,A,I2,A)') 'Enter A(', I, ',', J, '):'
      READ (*,*) A(I,J)
   END DO
END DO
! Get matrix B.

DO I = 1, N
   DO J = 1, M
      WRITE (*,'(1X,A,I2,A,I2,A)') 'Enter B(', I, ',', J, '):'
      READ (*,*) B(I,J)
   END DO
END DO

! Subtract matrices.

C = A - B

! Write out result.

WRITE (*,'(1X,A)') ' A - B = '
DO I = 1, N
   WRITE (*,'(4X,6(F7.2,2X))') ( C(I,J), J = 1, M )
END DO

END PROGRAM
